CON
  _clkmode = xtal1+pll16x
  _clkfreq = 80000000

OBJ
  fs  : "fsrw"
  ser : "FullDuplexSerial"
  ovl : "dummy"

VAR
  long firstvar

PUB main
  waitcnt(clkfreq*3+cnt)
  ser.start(31, 30, 0, 115200)
  fs.mount_explicit(10, 11, 9, 25)
  PrintOverlayReturnValue(string("test1.bin"))
  PrintOverlayReturnValue(string("test2.bin"))
  PrintOverlayReturnValue(string("test3.bin"))
  waitcnt(clkfreq/10+cnt)

PUB PrintOverlayReturnValue(fname)
  result := CallOverlay(fname)
  ser.str(fname)
  ser.str(string(" returned a value of "))
  ser.dec(result)
  ser.tx(13)

PUB CallOverlay(fname) | addr, size, pbase, vbase, dbase, vsize, nummet1, numobj, entryptr
  ' Load the object to a location 200 longs after the current stack pointer
  addr := @result + 800
  size := LoadFile(fname, addr)
  ifnot size
    return 0

  ' Get the values of pbase, vbase and dbase
  pbase := word[addr][3] + addr
  vbase := word[addr][4] + addr
  dbase := word[addr][5] + addr

  ' Determine the VAR size and zero it
  vsize := dbase - vbase - 8
  longfill(vbase, 0, vsize/4)

  ' Locate the method table entry for the last object
  nummet1 := byte[@@0][2]
  numobj := byte[@@0][3]
  entryptr := @@0 + (nummet1+numobj-1)*4

  ' Adjust the pbase and vbase offsets in the method table
  word[entryptr] := pbase - @@0
  word[entryptr][1] := vbase - @firstvar

  ' Call the first method in the object
  return ovl.main

PUB LoadFile(fname, addr)
  if result := \fs.popen(fname, "r")
    ser.str(string("Could not open "))
    ser.str(fname)
    ser.tx(13)
    return 0
  result := fs.pread(addr, 30000)
  fs.pclose
  